   {- ####################################################################################################
   ####                                                                                               ####
   ####             UNIVERSIDADE FEDERAL DO ESPIRITO SANTO                                            ####
   ####             CENTRO TECNOLOGICO                                                                ####
   ####             DEPARTAMENTO DE INFORMATICA                                                       ####
   ####             ENGENHARIA DE COMPUTACAO                                                          ####
   ####             Linguagens de Programacao 2019/2                                                  ####
   ####             Professor Vitor E. Silva Souza                                                    ####
   ####                                                                                               ####
   #######################################################################################################
   ####                                                                                               ####
   ####                                       TRABALHO SOBRE A                                        ####
   ####                                  A LINGUAGEM DE PROGRAMACAO                                   ####
   ####                                         H A S K E L L                                         ####
   ####                                                                                               ####
   #######################################################################################################
   ##################                                ***                                ##################
   ##################                            ArgsTester.hs                          ##################
   ##################                                ***                                ##################
   #######################################################################################################
   #######################################################################################################
   ####        AUTOR: Alan do Espirito Santo Vitorino                                                 ####
   ####               Bruno Gomes                                                                     ####
   ####               Victor de Oliveira                                                              ####
   ####                                                                                               ####
   ####        DATA ABERTURA: 07 de novembro de 2019, as 21h27min                                     ####
   ####        LOCAL: Brasil, Espirito Santo, Vitoria,                                                ####
   ####                                                                                               ####
   ####        VERSAO  1.0                                                                            ####
   ####                                                                                               ####
   ####        OBJETIVOS                                                                              ####
   ####           Definir funcoes e estruturas para verificar a qualidade e integridade dos           ####
   ####           parametros de entrada do programa executavel                                        ####
   ####                                                                                               ####
   ####        DESCRICAO                                                                              ####
   ####           O sistema necessita de 15 parametros para funcionar plenamente, a saber:            ####
   ####           - O primeiro constitui-se no nome do programa;                                      ####
   ####           - O segundo e um especificador que especifica o tipo de arquivo que virar a seguir; ####
   ####           - O terceiro e um arquivo do tipo especificado pelo especificador;                  ####
   ####           - e este padrao segue para os 7 arquivos de entrada.                                ####
   ####                                                                                               ####
   ####        FUNCIONALIDADES                                                                        ####
   ####             *                                                                                 ####
   ####        ORIENTACOES:                                                                           ####
   ####             *                                                                                 ####
   ####        PENDENCIAS:                                                                            ####
   ####                                                                                               ####
   ####        ATUALIZACOES/MODIFICACOES/ACRESCIMOS                                                   ####
   ####             * 2019_12_08_03h49min                                                             ####
   ####                - conclusao versao 1.0                                                         ####
   ####                                                                                               ####
   #################################################################################################### -}

module ArgsTester
(argsChecker
,checkerArgsB
,checkerArgsMsn
,thereIsPrm
,thereIsParamMiss
,isLastStr
,seekFile
)where
import System.Environment(getArgs)
{- ########################################################################################################################################################################## -}
{-                                                                              FUNCOES DO MODULO                                                                             -}
{- #############################################################################################################################################################################
        AUTOR: Alan do Espirito Santo Vitorino
        DATA ABERTURA: 24 de novembro de 2019, as 07h24min
        OBJETIVOS
           Verificar a integridade, qualidade e quantidade dos parametros de entrada ao qual sao passados ao programa executavel
        DESCRICAO
        FUNCIONALIDADES
        ORIENTACOES
        PENDENCIAS
        ATUALIZACOES/MODIFICACOES/ACRESCIMO -}
--
--
--
argsChecker:: IO()
argsChecker = do
   args <- getArgs -- IO [String]
   let qtd = length args
   putStr " Quantidade de argumentos passados na entrada:\n    "
   print qtd
   putStr " Argumentos que foram passados:\n    "
   putStrLn (show args)
--      DESCRICAO
--         Verifica a quantidade e o valor dos parametros de entrada do programa
--      PARAMETROS
--         Entrada:
--            Nenhum
--         Saida:
--            Mensagem em tela
--
--
checkerArgsB :: [String] -> Bool
checkerArgsB xs
   | (length xs)      == 14 = True
   | otherwise              = False
--      DESCRICAO
--         Verifica se a quantidade de paramentros de entrada obedecem os padroes da especificacao
--      PARAMETROS
--         Entrada:
--            xs - Lista de parametros passados no terminal para o programa (capturado por getArgs).
--         Saida:
--            True  - E retornado caso os parametros obedecam as especificacoes implementadas.
--            False - E retornado caso os parametros falhem em pelo menos uma especificacao implementada.
--
--
checkerArgsMsn :: [String] -> IO ()
checkerArgsMsn xs
   | (length xs)       == 0 = putStrLn "[Error] Nenhum argumento foi passado como entrada"
   | mod (length xs) 2 == 1 = putStrLn "[Error] Quantidade impar de argumentos - Entrar especificador seguido de nome do arquivo a ser aberto."
   | (length xs)       > 14 = putStrLn "[Error] mais de 14 argumentos foram passados"
   | (length xs)       < 14 = putStrLn "[Error] menos de 14 argumentos foram passados"
   | otherwise              = putStrLn "[Ok---] 14 parametros passados"
--      DESCRICAO
--         Imprime no terminal o erro encontrado nos parametros de entrada e orienta correcoes.
--      PARAMETROS
--         Entrada:
--            xs - Lista de parametros passados no terminal para o programa (capturado por getArgs).
--         Saida:
--            IO - Mensagem na tela acerca do erro encontrado.
--      ORIENTACOES
--         Os parametros deve estar presentes em quantidade par: o especificacor e o nome do arquivo especificado
--         Exemplo ./meu_programa.exe -d docentes.csv
--         A especificacao define 7 arquivos de entrada com seus respectivos especificadores, logo, deve-se ter 14 argumentos passados para o programa executavel.
--
--
thereIsPrm :: String -> [String] -> Bool
thereIsPrm param args = elem True [ param==p | p<-args]
--      DESCRICAO
--         Verifica se um parametro especifico encontra-se entre os argumentos passados para o programa
--      OBJETIVO
--            Destina-se a verificar se um especificador de um arquivo encontra-se na lista de argumentos passados como parametros para o programa
--      PARAMETROS
--         Entrada:
--            param - Parametro ao qual quer-se saber se esta listado dentre os contidos na lista de argumentos.
--            args  - Lista de argumentos passados para o programa.
--         Saida:
--            True  - Caso o parametro esteja contido na lista
--            False - Caso o parametro nao esteja contido na lista
--
--
thereIsParamMiss :: [String] -> [String] -> Bool
thereIsParamMiss lsParam args = elem False [thereIsPrm param args | param<-lsParam]
--      DESCRICAO
--         Verifica se um conjunto de parametro encontra-se entre os argumentos passados para o programa
--      OBJETIVO
--         Verificar se uma lista de especificadores, necessarios e inprescindiveis para a execucao do programa,
--         encontram-se contidos nos parametros passados para o programa
--      PARAMETROS
--         Entrada:
--            lsParam - Lista de parametroas ao qual se deseja verificar.
--            args    - Lista de argumentos capturados do terminal.
--         Saida:
--            True  - Caso pelo menos um parametro nao esteja contido na lista.
--            False - Caso todos os parametro estejam contido na lista.
--
--
isLastStr :: Eq a => [a] -> a -> Bool
isLastStr args param = (last args == param)
--      DESCRICAO
--         Verifica se um especificador e o ultimo elementos da lista de argumentos.
--      PARAMETROS
--         Entrada:
--            args  - Lista de argumentos.
--            param - Parametro ao qual quer-se verificar.
--         Saida:
--            True  - Caso o parametro seja o ultimo argumento.
--            False - Caso contrario
--      ORIENTACOES
--         O especificador nao pode ser o ultimo parametro.
--
--
seekFile :: [String] -> String -> String
seekFile [] param = ""
seekFile (x:xs) param
   | x==param   = head xs
   | otherwise = seekFile xs param
--      DESCRICAO
--         Dado uma especificador retorna a string seguinte de dentro de uma lista
--      OBJETIVO
--         Atraves de um especificador, pode-se obter o nome do arquivo especificado de uma lista de parametros de entrada do programa
--      PARAMETROS
--         Entrada:
--            (x:xs) - Lista de argumentos.
--            param  - String especificador do arquivo.
--         Saida:
--            String com o nome do arquivo a ser aberto.
--
--
--
--
--
{- ########################################################################################################################################################################## -}
{-                                                                                     MAIN                                                                                   -}
{- ###########################################################################################################################################################################-}
main :: IO()
main = do
   args <- getArgs
   putStrLn "############################################################################################################################################################"
   putStrLn "                                                        BATERIA DE TESTES DO MODULO ArgsTester.hs"
   putStrLn "############################################################################################################################################################"
   putStrLn "\nTESTE [001] - VERIFICACAO DA QUANTIDADE E DOS VALORES DOS PARAMETROS DE ENTRADA"
   argsChecker
   putStrLn "\nTESTE [002] - OS PARAMETROS DE ENTRADA ESTAO EM QUATIDADE CORRETA?"
   putStrLn (show(checkerArgsB args))
   putStrLn "\nTESTE [003] - APRESENTAR DESCRICAO DE ERROS"
   checkerArgsMsn args

   putStrLn "|=====================================================|"
   putStrLn "|                  ArgsTester.hs 1.0                  |"
   putStrLn "|               developed and designed                |"
   putStrLn "|                    by Alanesvit                     |"
   putStrLn "|=====================================================|"


