   {- ####################################################################################################
   ####                                                                                               ####
   ####             UNIVERSIDADE FEDERAL DO ESPIRITO SANTO                                            ####
   ####             CENTRO TECNOLOGICO                                                                ####
   ####             DEPARTAMENTO DE INFORMATICA                                                       ####
   ####             ENGENHARIA DE COMPUTACAO                                                          ####
   ####             Linguagens de Programacao 2019/2                                                  ####
   ####             Professor Vitor E. Silva Souza                                                    ####
   ####                                                                                               ####
   #######################################################################################################
   ####                                                                                               ####
   ####                                       TRABALHO SOBRE A                                        ####
   ####                                    A LINGUAGEM DE PROGRAMACAO                                 ####
   ####                                         H A S K E L L                                         ####
   ####                                                                                               ####
   #######################################################################################################
   ##################                                ***                                ##################
   ##################                       AtividadesDocentes.sh                       ##################
   ##################                                ***                                ##################
   #######################################################################################################
   #######################################################################################################
   ####        AUTOR: Alan do Espirito Santo Vitorino                                                 ####
   ####               Bruno Gomes                                                                     ####
   ####               Victor de Oliveira                                                              ####
   ####                                                                                               ####
   ####        DATA ABERTURA: 29 de novembro de 2019, as 14h26min                                     ####
   ####        LOCAL: Brasil, Espirito Santo, Vitoria,                                                ####
   ####                                                                                               ####
   ####        DATA ENCERRAMENTO: 13 de dezembro de 2019, as 12h00min                                 ####
   ####        LOCAL: Brasil, Espirito Santo, Vitoria,                                                ####
   ####                                                                                               ####
   ####        VERSAO  1.2                                                                            ####
   ####                                                                                               ####
   ####        OBJETIVOS                                                                              ####
   ####           Definir procedimentos e estruturas de dados para a manipulacao dos arquivos de en-  ####
   ####           trada da especificacao                                                              ####
   ####                                                                                               ####
   ####        DESCRICAO                                                                              ####
   ####             *                                                                                 ####
   ####        FUNCIONALIDADES                                                                        ####
   ####             *                                                                                 ####
   ####        ORIENTACOES:                                                                           ####
   ####             *                                                                                 ####
   ####        PENDENCIAS:                                                                            ####
   ####             *                                                                                 ####
   ####        ATUALIZACOES/MODIFICACOES/ACRESCIMOS                                                   ####
   ####             * 2019_12_13_12h00min                                                             ####
   ####                  - Conclusao v 1.2                                                            ####
   ####                    + Versao de entrega                                                        ####
   ####                                                                                               ####
   #################################################################################################### -}
module DocsSpecifications
(specs
,pad
,rha
,alo
,ppg
,headerPAD
,headerRHA
,headerAlo
,headerPPG
,readDocent
,readDiscen
,readProCie
,readCursos
,readDiscip
,readOriGra
,readOriPos
) where
import ArgsTester
--
{- ########################################################################################################################################################################## -}
{-                                                                              FUNCOES DO MODULO                                                                             -}
{- #############################################################################################################################################################################
        AUTOR: Alan do Espirito Santo Vitorino
        DATA ABERTURA: 08 de dezembro de 2019, as 19h08min
        OBJETIVOS
           Estabelecer constantes, funcoes e estruturas de dados que obedecam a especificacao dos arquivos de entrada e saida.
        DESCRICAO
        FUNCIONALIDADES
        ORIENTACOES
           O sistema depende de 7 arquivos de entrada de dados, no formato csv, ao qual devem ter seus conteudos lidos e processados para se obter a computacao
           a que se deseja:
           PLANILHA DE DOCENTES
              Especificador: -d
              Campos: |   <código>    |    <nome>     | <departamento>
              Valor:  |      Int      |    String     |     String
              Descric |               |               |--> Departamento de atuacao do docente
                      |               |--> Nome do docente
                      |--> Codigo do docente

           PLANILHA DE DISCENTES
              Especificador: -a
              Campos: |  <matricula>  |     <nome>    | <cód do curso>
              Valor:  |      Int      |     String    |      Int
              Descric |               |               |--> Codigo do curso (graduacao ou pos graduacao) 
                      |               |--> Nome do discente
                      |--> Codigo numerico com 10 digitos

           PLANILHA DE PRODUCOES CIENTIFICAS
              Especificador: -p
              Campos: | <cód docente> | <tit da pub>  | <qualificada?>
              Valor:  |      Int      |    String     |     String
              Descric |               |               |--> campo marcado com texto "X" caso a publicacao seja qualificada
                      |               |--> Nome testual da publicacao
                      |--> Codigo do docente

           PLANILHA DE CURSOS
              Especificador: -c
              Campos: |<cód do curso> |<nome do curso>|  <graduação?> |<pós-graduação?>
              Valor:  |      Int      |    String     |    String     |    String     
              Descric |               |               |               |--> campo marcado com texto "X" caso aseja curso de pos-graduacao
                      |               |               |--> campo marcado com texto "X" caso aseja curso de graduacao
                      |               |--> Texto com nome do curso
                      |--> Codigo do curso

           PLANILHA DE DISCIPLINAS (Atividade Didatico-Aula)
              Especificador: -r
              Campos: |    <código>   |     <nome>    |<código docent>|<carga horar 7>|<carga hor 180>|<código do curso>
              Valor:  |     String    |     String    |      Int      |      Int      |      Int      |      Int      
              Descric |               |               |               |               |               |--> Codigo do curso
                      |               |               |               |               |--> Carga horaria semestral
                      |               |               |               |--> Carga horaria semanal
                      |               |               |--> Codigo do docente
                      |               |--> Texto com nome do docente
                      |--> Codigo da disciplina alfanumerico

           PLANILHA DE ORIENTACAO DE DISCENTES DE GRADUACAO
              Especificador: -og
              Campos: |<cod do docent>|<mat do discen>|    <curso>    |<carga horaria semanal>
              Valor:  |     String    |     String    |      Int      |      Int
              Descric |               |               |               |--> Carga horaria semanal
                      |               |               |--> Codigo do curso
                      |               |--> Matricula do discente orientado
                      |--> Codigo do docente

           PLANILHA DE ORIENTACAO DE DISCENTES DE POS-GRADUACAO
              Especificador: -op
              Campos: |<cod do docent>|<mat do discen>|<data de ingre>|<prog de pós g>| <carga horária-semanal>
              Valor:  |      Int      |       Int     |      Data     |     String    |           Int      
                      |               |               |               |               |--> Carga horaria semanal
                      |               |               |               |--> Nome do programa de pos-graduacao
                      |               |               |--> Data de ingresso do discente no programa
                      |               |--> Matricula do discente orientado
                      |--> Codigo do docente
        PENDENCIAS
        ATUALIZACOES/MODIFICACOES/ACRESCIMOS
             * 2019_xx_xx_xxxx -}
--
--
--
--
--
{- Especificadores-}
specs :: [String]
specs = ["-d","-a","-p","-c","-r","-og","-op"]
-- Define os especificadores de arquivo
--      DESCRICAO
--         A lista <specs> constitui-se de String que sao usadas para especificar o tipo de arquivo a ser aberto, na sequencia de parametros passados ao programa executavel
--         Abaixo ha a lista de especificadores e os arquivos ao qual eles referenciam:
--            -d  - planilha de docentes
--            -a  - planilha de discentes
--            -p  - planilha de producoes cientificas
--            -c  - planilha de cursos
--            -r  - planilha de disciplinas
--            -og - planilha de orientacao de discentes de graduacao
--            -op - planilha de orientacao de discentes de pos-graduacao
--         Todas as planilhas estao no formato csv
--        ORIENTACOES
--           Um especificador seguido de uma palavra significa que a palavra eh um arquivo de dados, de extensao csv, do tipo especificado pelo especificador 
--        EXEMPLO
--           meu_programa.exe -d professores.csv
--           O programa executável entendera, pelo especificador -d, que professores.csv e um arquivo de docentes
--
--
--
--
--
pad :: String
pad = "1-pad.csv"
--      DESCRICAO
--         Define o nome do arquivo de Plano Semestral de Atividades Docentes
--
rha :: String
rha = "2-rha.csv"
--      DESCRICAO
--         Define o nome do arquivo de Relatorio de Horas Aula
--
alo :: String
alo = "3-alocacao.csv"
--      DESCRICAO
--         Define o nome do arquivo de Tabela de Alocacao de Disciplinas
--
ppg :: String
ppg = "4-ppg.csv"
--      DESCRICAO
--         Define o nome do arquivo de Lista de Discentes de Pos-Graduacao
--
--
headerPAD :: String
headerPAD = "DOCENTE; DEPARTAMENTO;TOTAL horas semanais aulas;TOTAL horas semestrais aulas;total horas semanais orient;NUM de prod cient qualif;NUM prod cient nao qualif"
--      DESCRICAO
--         Define o cabecalho do arquivo de Lista de Discentes de Pos-Graduacao
--
headerRHA :: String
headerRHA = "nome do DEPARTAMENTO;<nome do DOCENTE;codigo do curso;nomedo curso;total horas semestrais aulas"
--      DESCRICAO
--         Define o cabecalho do arquivo de Lista de Discentes de Pos-Graduacao
--
headerAlo :: String
headerAlo = "nome do docente;codigo da disciplina;nome da disciplina;carga horaria semestral"
--      DESCRICAO
--         Define o cabecalho do arquivo de Lista de Discentes de Pos-Graduacao
--
headerPPG :: String
headerPPG = "nome do programa de pos-graduacao;data de ingresso do discente no programa;matricula do discente;nome do discente"
--      DESCRICAO
--         Define o cabecalho do arquivo de Lista de Discentes de Pos-Graduacao
--
--
--
readDocent :: [String] -> IO [String]
readDocent argv = do
                       conteudo <-readFile (seekFile argv "-d")       -- Abre o arquivo para leitura
                       let docen = lines conteudo                      -- Le todo o conteudo do arquivo 
                       return (drop 1 docen)                           -- Joga a primeira linha fora
readDiscen :: [String] -> IO [String]
readDiscen argv = do
                       conteudo <-readFile (seekFile argv "-a")
                       let docen = lines conteudo
                       return (drop 1 docen)
readProCie :: [String] -> IO [String]
readProCie argv = do
                       conteudo <-readFile (seekFile argv "-p")
                       let docen = lines conteudo
                       return (drop 1 docen)
readCursos :: [String] -> IO [String]
readCursos argv = do
                       conteudo <-readFile (seekFile argv "-c")
                       let docen = lines conteudo
                       return (drop 1 docen)
readDiscip :: [String] -> IO [String]
readDiscip argv = do
                       conteudo <-readFile (seekFile argv "-r")
                       let docen = lines conteudo
                       return (drop 1 docen)
readOriGra :: [String] -> IO [String]
readOriGra argv = do
                       conteudo <-readFile (seekFile argv "-og")
                       let docen = lines conteudo
                       return (drop 1 docen)
readOriPos :: [String] -> IO [String]
readOriPos argv = do
                       conteudo <-readFile (seekFile argv "-op")
                       let docen = lines conteudo
                       return (drop 1 docen)
--      DESCRICAO
--         Retorna o conteudo do arquivo como uma lista de linhas.
--         Entrada:
--            argv - Lista de argumentos que foram passados como parametro para o programa no terminal.
--         Saida:
--            Uma lista de linhas do arquivo
--
--
--
{- ########################################################################################################################################################################## -}
{-                                                                                     MAIN                                                                                   -}
{- ###########################################################################################################################################################################-}
main :: IO()
main = do
   putStrLn "|=====================================================|"
   putStrLn "|             DocsSpecifications.hs 1.2               |"
   putStrLn "|               developed and designed                |"
   putStrLn "|                    by Alanesvit                     |"
   putStrLn "|=====================================================|"




