   {- ####################################################################################################
   ####                                                                                               ####
   ####             UNIVERSIDADE FEDERAL DO ESPIRITO SANTO                                            ####
   ####             CENTRO TECNOLOGICO                                                                ####
   ####             DEPARTAMENTO DE INFORMATICA                                                       ####
   ####             ENGENHARIA DE COMPUTACAO                                                          ####
   ####             Linguagens de Programacao 2019/2                                                  ####
   ####             Professor Vitor E. Silva Souza                                                    ####
   ####                                                                                               ####
   #######################################################################################################
   ####                                                                                               ####
   ####                                       TRABALHO SOBRE A                                        ####
   ####                                  A LINGUAGEM DE PROGRAMACAO                                   ####
   ####                                         H A S K E L L                                         ####
   ####                                                                                               ####
   #######################################################################################################
   ##################                                ***                                ##################
   ##################                        FileManipulator.hs                         ##################
   ##################                                ***                                ##################
   #######################################################################################################
   #######################################################################################################
   ####        AUTOR: Alan do Espirito Santo Vitorino                                                 ####
   ####               Bruno Gomes                                                                     ####
   ####               Victor de Oliveira                                                              ####
   ####                                                                                               ####
   ####        DATA ABERTURA: 07 de novembro de 2019, as 21h27min                                     ####
   ####        LOCAL: Brasil, Espirito Santo, Vitoria,                                                ####
   ####                                                                                               ####
   ####        DATA ENCERRAMENTO: 13 de dezembro de 2019, as 12h00min                                 ####
   ####        LOCAL: Brasil, Espirito Santo, Vitoria                                                 ####
   ####                                                                                               ####
   ####        VERSAO  1.2                                                                            ####
   ####                                                                                               ####
   ####        OBJETIVOS                                                                              ####
   ####           Definir todas as funcionalidades referentes a abertura, manipulacao e fechamento de ####
   ####           arquivos                                                                            ####
   ####                                                                                               ####
   ####        DESCRICAO                                                                              ####
   ####           Constitui-se de funcoes e estruturas de dados que possibilitam a manipuacao de dados####
   ####           provenientes dos arquivos de 7 arquivos de entrada, conforme definidos na           ####
   ####           na especificacao do projeto.                                                        ####
   ####                                                                                               ####
   ####        PENDENCIAS:                                                                            ####
   ####                    - Tratamento de excecao para abertura de arquivo                           ####
   ####                                                                                               ####
   ####        ATUALIZACOES/MODIFICACOES/ACRESCIMOS                                                   ####
   ####             * 2019_10_25_21h00min                                                             ####
   ####                  - Conclusao v 1.0                                                            ####
   ####                    Esta versao estabelece a capacidade de:                                    ####
   ####                    + Abrir arquivo para leitura;                                              ####
   ####                    + Criar arquivo para escrita;                                              ####
   ####                    + Ler arquivo aberto;                                                      ####
   ####                    + Escrever linha em arquivo feito.                                         ####
   ####                                                                                               ####
   ####             * 2019_12_06_21h24min                                                             ####
   ####                  - Conclusao v 1.1                                                            ####
   ####                    Esta versao estabelece a capacidade de:                                    ####
   ####                    + Criar o arquivo 2-rha.csv dentro das especificacoes                      ####
   ####             * 2019_12_13_12h00min                                                             ####
   ####                  - Conclusao v 1.2                                                            ####
   ####                    + Versao de entrega                                                        ####
   ####                                                                                               ####
   #################################################################################################### -}

module FileManipulator
(criaDocPAD
,criaDocRHA
,criaDocAlo
,criaDocPPG
,putLnPAD
,putLnRHA
,putLnALO
,putLnPPG
,groupN
,get7N
,quicksortPAD
,quicksortRHA
,quicksortALO
,quicksortPPG
,somaRHA
,somaPAD
,putLsUplaRHA
,putLsUplaPAD
,putLsUplaALO
,putLsUplaPPG
,procData
)where
import ArgsTester
import DocsSpecifications
import System.Environment(getArgs)
import Data.List.Split -- Biblioteca para usar a funo splitOn. Teve que ser baixada -> sudo apt-get install cabal-install 
--import Data.List
--import System.IO
--import Control.Monad(when)
--import System.Exit
--import System.Directory
--import System.IO.Error	-- No caso, cabal install split e cabal install exit
--
--
{- ########################################################################################################################################################################## -}
{-                                                                              FUNCOES DO MODULO                                                                             -}
{- #############################################################################################################################################################################
        AUTOR: Alan do Espirito Santo Vitorino
        DATA ABERTURA: 24 de novembro de 2019, as 15h35min
        OBJETIVOS
        Estabelecer funcoes que favorecem a manipuilacao de arquivos para leitura e escrita.
        -}
--
--
--
somaPAD :: [(String,String,String,String,String,String,String)] -> [(String,String,String,String,String,String,String)]
somaPAD (x:y:xs)
   |(x:y:xs) == []    = []
   |(x:y:xs) == [x]   = [x]
   |     xs  == []    = if (igual_U_PAD x y)
                           then [(soma_U_PAD x y)]
                           else  [x] ++ [y]
   |(igual_U_PAD x y) = somaPAD ([soma_U_PAD x y]++xs)
   | otherwise        = [x] ++ (somaPAD (y:xs))
--
--
somaRHA :: [(String,String,String,String,String,String,String)] -> [(String,String,String,String,String,String,String)]
somaRHA (x:y:xs)
   |(x:y:xs) == []    = []
   |(x:y:xs) == [x]   = [x]
   |     xs  == []    = if (igual_U_RHA x y)
                           then [(soma_U_RHA x y)]
                           else  [x] ++ [y]
   |(igual_U_RHA x y) = somaRHA ([soma_U_RHA x y]++xs)
   | xs == []         = [x] ++ [y]
   | otherwise        = [x] ++ (somaRHA (y:xs))
--
--      DESCRICAO
--         Dada uma lista de 7-uplas, a funcao soma campos especificos das 7-uplas tal que guardam certos padroes de igualdade em outros campos da mesma 7-upla
--      PARAMETROS
--         Entrada:
--            Lista de 7-upla
--         Saida:
--            Lista de 7-uplas com certas uplas mescladas ao ter certos campos somados
--      PRE-REQUISITO
--         1st - O campo da upla a ser somado deve ser uma string que representa um inteiro tal que possa ser convertido pela funcao read, do contrario, retorna erro.
--         2nd - As uplas que obedecem o padrao de igualdade para que sejam somadas devem estar em sequencia para que o algoritmo funcione,
--               para isso use o quicksort para ordenar as 7-uplas de forma que fique sequenciadas.
--
--
--
--
--
soma_U_PAD :: (String,String,String,String,String,String,String) -> (String,String,String,String,String,String,String) -> (String,String,String,String,String,String,String)
soma_U_PAD  ( docente1 , depart1 , ch7aula1 , ch180aula1 , ch7ori1 , simQualif1 , naoQualif1)
             ( docente2 , depart2 , ch7aula2 , ch180aula2 , ch7ori2 , simQualif2 , naoQualif2) =
             ( docente2 , depart2 , show((read ch7aula1)   + (read ch7aula2)) ,
                                    show((read ch180aula1) + (read ch180aula2)),
                                    show((read ch7ori1)    + (read ch7ori2)),
                                    show((read simQualif1) + (read simQualif2)),
                                    show((read naoQualif1) + (read naoQualif2)))
--
--
soma_U_RHA :: (String,String,String,String,String,String,String) -> (String,String,String,String,String,String,String) -> (String,String,String,String,String,String,String)
soma_U_RHA (depart1, nomDoc1, codCur1, nomCur1, ch180_1,ni1,nil1)
         (depart2, nomDoc2, codCur2, nomCur2, ch180_2,ni2,nil2) =
         (depart2, nomDoc2, codCur2, nomCur2, show((read ch180_1)+(read ch180_2)),ni2,nil2)
--
--      DESCRICAO
--         Funcao soma campos especificos das 7-uplas tal que guardam certos padroes de igualdade em outros campos da mesma 7-upla
--      PARAMETROS
--         Entrada:
--            1 - 7-upla
--            2 - 7-upla
--         Saida:
--            7-upla mesclada com certos campos numericos somados
--      PRE-REQUISITO
--         1st - O campo da upla a ser somado deve ser uma string que representa um inteiro tal que possa ser convertido pela funcao read, do contrario, retorna erro.
--         2nd - As uplas que obedecem o padrao de igualdade para que sejam somadas devem estar em sequencia para que o algoritmo funcione,
--               para isso use o quicksort para ordenar as 7-uplas de forma que fique sequenciadas.
--
--
--
--
--
menor_U_PAD :: (String,String,String,String,String,String,String) -> (String,String,String,String,String,String,String) -> Bool
menor_U_PAD  ( docente1 , depart1 , ch7aula1 , ch180aula1 , a1 , b1 , c1 )
             ( docente2 , depart2 , ch7aula2 , ch180aula2 , a2 , b2 , c2 ) = docente1 < docente2
--
--
menor_U_RHA :: (String,String,String,String,String,String,String) -> (String,String,String,String,String,String,String) -> Bool
menor_U_RHA (depart1, nomDoc1, codCur1, nomCur1, sCH1801, a1, b1)
            (depart2, nomDoc2, codCur2, nomCur2, sCH1802, a2, b2)
   | (depart1==depart2) && (nomDoc1==nomDoc2) = nomCur1 < nomCur2
   | (depart1==depart2)                       = nomDoc1 < nomDoc2
   | otherwise                                = depart1 < depart2
--
--
menor_U_ALO :: (String,String,String,String,String,String,String) -> (String,String,String,String,String,String,String) -> Bool
menor_U_ALO  ( nomeDoc1, codDisc1, nomeDisc1, cH1801, a1, b1, c1)
             ( nomeDoc2, codDisc2, nomeDisc2, cH1802, a2, b2, c2)
   | nomeDoc1 == nomeDoc2 = codDisc1 < codDisc2
   | otherwise            = nomeDoc1 < nomeDoc2
--
--
menor_U_PPG :: (String,(Int,String),String,String,String,String,String) -> (String,(Int,String),String,String,String,String,String) -> Bool
menor_U_PPG  ( nomeProg1, data1, matricula1, nomeDisc1, a1, b1, c1)
             ( nomeProg2, data2, matricula2, nomeDisc2, a2, b2, c2)
   | (nomeProg1==nomeProg2) && (data1==data2) = matricula1 < matricula2
   | (nomeProg1==nomeProg2)                   = fst data1 < fst data2
   | otherwise                                = nomeProg1 < nomeProg2
--
--      DESCRICAO
--         Estabelece relacao de ordenacao (menor) entre as uplas de acordo com especificacao de cada relatorio
--      PARAMETROS
--         Entrada:
--            1 - 7-upla
--            2 - 7-upla
--         Saida:
--            Valor Boleano
--
--
--
--
--
igual_U_PAD :: (String,String,String,String,String,String,String) -> (String,String,String,String,String,String,String) -> Bool
igual_U_PAD  ( docente1 , depart1 , ch7aula1 , ch180aula1 , a1 , b1 , c1 )
             ( docente2 , depart2 , ch7aula2 , ch180aula2 , a2 , b2 , c2 ) = docente1 == docente2
--
--
igual_U_RHA :: (String,String,String,String,String,String,String) -> (String,String,String,String,String,String,String) -> Bool
igual_U_RHA (depart1, nomDoc1, codCur1, nomCur1, ch180_1, a1, b1)
            (depart2, nomDoc2, codCur2, nomCur2, ch180_2, a2, b2) = (depart1==depart2) && (nomDoc1==nomDoc2) && (nomCur1==nomCur2)
--
--
igual_U_ALO :: (String,String,String,String,String,String,String) -> (String,String,String,String,String,String,String) -> Bool
igual_U_ALO  ( nomeDoc1, codDisc1, nomeDisc1, cH1801, a1, b1, c1)
             ( nomeDoc2, codDisc2, nomeDisc2, cH1802, a2, b2, c2) = (nomeDoc1 == nomeDoc2) && (codDisc1 < codDisc2)
--
--
igual_U_PPG :: (String,String,String,String,String,String,String) -> (String,String,String,String,String,String,String) -> Bool
igual_U_PPG  ( nomeProg1, data1, matricula1, nomeDisc1, a1, b1, c1)
             ( nomeProg2, data2, matricula2, nomeDisc2, a2, b2, c2) = (nomeProg1==nomeProg2) && (data1==data2) && (matricula1 < matricula2)
--
--      DESCRICAO
--         Estabelece relacao de igualdade entre as uplas.
--      PARAMETROS
--         Entrada:
--            1 - 7-upla
--            2 - 7-upla
--         Saida:
--            Valor Boleano
--
--
--
--
--
maiorIgual_U_PAD :: (String,String,String,String,String,String,String) -> (String,String,String,String,String,String,String) -> Bool
maiorIgual_U_PAD  ( docente1 , depart1 , ch7aula1 , ch180aula1 , a1 , b1 , c1 ) ( docente2 , depart2 , ch7aula2 , ch180aula2 , a2 , b2 , c2 ) = docente1 >= docente2
--
--
maiorIgual_U_RHA :: (String,String,String,String,String,String,String) -> (String,String,String,String,String,String,String) -> Bool
maiorIgual_U_RHA (depart1 ,nomDoc1, codCur1 ,nomCur1 ,sCH1801 ,ni1, nil1) (depart2 ,nomDoc2, codCur2 ,nomCur2 ,sCH1802 ,ni2, nil2)
   | (depart1==depart2) && (nomDoc1==nomDoc2) = nomCur1 >= nomCur2
   | (depart1==depart2)                       = nomDoc1 >= nomDoc2
   | otherwise                                = depart1 >= depart2
--
--
maiorIgual_U_ALO :: (String,String,String,String,String,String,String) -> (String,String,String,String,String,String,String) -> Bool
maiorIgual_U_ALO  ( nomeDoc1, codDisc1, nomeDisc1, cH1801, a1, b1, c1)
                  ( nomeDoc2, codDisc2, nomeDisc2, cH1802, a2, b2, c2)
   | nomeDoc1 == nomeDoc2 = codDisc1 >= codDisc2
   | otherwise            = nomeDoc1 >= nomeDoc2
--
--
maiorIgual_U_PPG :: (String,(Int,String),String,String,String,String,String) -> (String,(Int,String),String,String,String,String,String) -> Bool
maiorIgual_U_PPG  ( nomeProg1, data1, matricula1, nomeDisc1, a1, b1, c1)
                  ( nomeProg2, data2, matricula2, nomeDisc2, a2, b2, c2)
   | (nomeProg1==nomeProg2) && (data1==data2) = matricula1 >= matricula2
   | (nomeProg1==nomeProg2)                   = fst data1 >= fst data2
   | otherwise                                = nomeProg1 >= nomeProg2
--
--      DESCRICAO
--         Estabelece relacao de ordenacao (maior ou igual) entre as uplas.
--      PARAMETROS
--         Entrada:
--            1 - 7-upla
--            2 - 7-upla
--         Saida:
--            Valor Boleano
--
--
--
--
--
criaDocPAD = appendFile pad headerPAD
criaDocRHA = appendFile rha headerRHA
criaDocAlo = appendFile alo headerAlo
criaDocPPG = appendFile ppg headerPPG
--
--      DESCRICAO
--         Cria o arquivo de saida especifico com o cabecalho tambem especifico.
--      PARAMETROS
--         Entrada:
--            Nao ha
--         Saida:
--            Arquivo de extensao csv com o nome e o cabecalho ambos definidos no modulo DocSpecification
--
--
--
--
--
putLnPAD :: String -> IO ()
putLnPAD line = appendFile pad line
--
putLnRHA :: String -> IO ()
putLnRHA line = appendFile rha line
--
putLnALO :: String -> IO ()
putLnALO line = appendFile alo line
--
putLnPPG :: String -> IO ()
putLnPPG line = appendFile ppg line
--
--      DESCRICAO
--         Insere a String line como uma linha apos a ultima linha do arquivo
--      PARAMETROS
--         Entrada:
--            line: A String que sera inserida apos a ultima linha do documento.
--         Saida:
--            O arquivo *.csv correspondente tera a String line inserida na ultima linha.
--
--
--
--
--
linePPG :: ([Char], (a, [Char]), [Char], [Char], t, t1, t2) -> [Char]
linePPG (x,y,z,a,b,c,w) = "\n" ++  x ++";"++ (snd y) ++";"++ z ++ ";" ++ a
--
line4 :: (String,String,String,String,String,String,String) -> String
line4 (x,y,z,a,b,c,w) = "\n" ++ x ++";"++ y ++";"++ z ++ ";" ++ a
--
line5 :: (String,String,String,String,String,String,String) -> String
line5 (x,y,z,a,b,c,w) = "\n" ++ x ++";"++ y ++";"++ z ++ ";" ++ a ++ ";" ++ b
--
lineUpla :: (String,String,String,String,String,String,String) -> String
lineUpla (x,y,z,a,b,c,w) = "\n" ++ x ++";"++ y ++";"++ z ++ ";" ++ a ++ ";" ++ b ++ ";"++ c ++ ";" ++ w
--
--      DESCRICAO
--         Tranforma uma 7-upla de string em uma string unica, no padrao csv, e descarta os campos nulos, sem valores.
--      PARAMETROS
--         Entrada:
--            7-upla
--         Saida:
--            String
--
--
--
--
--
putLsUplaRHA :: [(String, String, String, String, String, String, String)] -> IO ()
putLsUplaRHA (x:xs)
   | (x:xs) == [] = putLnRHA ""
   |    xs  == [] = putLnRHA (line5 x)
   | otherwise    = do
                      putLnRHA (line5 x)
                      putLsUplaRHA xs
--
putLsUplaPAD :: [(String, String, String, String, String, String, String)] -> IO ()
putLsUplaPAD (x:xs)
   | (x:xs) == [] = putLnPAD ""
   |    xs  == [] = putLnPAD (lineUpla x)
   | otherwise    = do
                      putLnPAD (lineUpla x)
                      putLsUplaPAD xs
--
putLsUplaALO :: [(String, String, String, String, String, String, String)] -> IO ()
putLsUplaALO (x:xs)
   | (x:xs) == [] = putLnALO ""
   |    xs  == [] = putLnALO (line4 x)
   | otherwise    = do
                      putLnALO (line4 x)
                      putLsUplaALO xs
--
--putLsUplaPPG :: [(String, String, String, String, String, String, String)] -> IO ()
putLsUplaPPG (x:xs)
   | (x:xs) == [] = putLnPPG ""
   |    xs  == [] = putLnPPG (linePPG x)
   | otherwise    = do

                      putLnPPG (linePPG x)
                      putLsUplaPPG xs
--
--      DESCRICAO
--         Dada uma lista de 7-uplas, a funcao imprime em arquivo, ao converter cada 7-upla em uma linha
--      PARAMETROS
--         Entrada:
--            Lista de 7-upla
--         Saida:
--            Escreve dados em arquivo
--
--
--
--
--
{- ########################################################################################################################################################################## -}
{-                                                                            FUNCOES DO AUXILIARES                                                                           -}
{- ###########################################################################################################################################################################-}
quicksortPAD :: [(String, String, String, String, String, String, String)] -> [(String, String, String, String, String, String, String)]
quicksortPAD [] = []
quicksortPAD (p:xs) = (quicksortPAD lesser) ++ [p] ++ (quicksortPAD greater)
   where
      lesser = filter (menor_U_PAD p) xs
      greater = filter (maiorIgual_U_PAD p) xs
--
--
quicksortRHA :: [(String, String, String, String, String, String, String)] -> [(String, String, String, String, String, String, String)]
quicksortRHA [] = []
quicksortRHA (p:xs) = (quicksortRHA lesser) ++ [p] ++ (quicksortRHA greater)
   where
      lesser = filter (menor_U_RHA p) xs
      greater = filter (maiorIgual_U_RHA p) xs
--
--
quicksortALO :: [(String, String, String, String, String, String, String)] -> [(String, String, String, String, String, String, String)]
quicksortALO [] = []
quicksortALO (p:xs) = (quicksortALO lesser) ++ [p] ++ (quicksortALO greater)
   where
      lesser = filter (menor_U_ALO p) xs
      greater = filter (maiorIgual_U_ALO p) xs
--
--
quicksortPPG :: [(String, (Int, String), String, String, String, String, String)] -> [(String, (Int, String), String, String, String, String, String)]
quicksortPPG [] = []
quicksortPPG (p:xs) = (quicksortPPG lesser) ++ [p] ++ (quicksortPPG greater)
   where
      lesser = filter (menor_U_PPG p) xs
      greater = filter (maiorIgual_U_PPG p) xs
--
--      DESCRICAO
--         Ordena as uplas referentes a cada arquivo de saida, de acordo com os criterios de ordenacao dos relatorios
--      PARAMETROS
--         Entrada:
--            Lista de 7-upla
--         Saida:
--            A lista ordenada
--
--
--
--
--
procData :: (Integral t, Read t) => [Char] -> (t, [Char])
procData string = (dia + acumMes!!(mes-1) + (ano-1)*365 + (div (ano-1) 4),string)
   where
     acumMes = [0,31,59,90,120,151,181,212,243,273,304,334]
     datadate = splitOn "/" string
     dia = read(datadate!!0)
     mes = read(datadate!!1)
     ano = read(datadate!!2)
--
--      DESCRICAO
--         Converte uma data para um valor numerico correpondente a quantidade de dias desde o dia 1 de JANEIRO de 1 DC. 
--      PARAMETROS
--         Entrada:
--            Lista de 7-upla
--         Saida:
--            Escreve dados em arquivo
--
--
--
--
--
fst_7 :: (t1,t2,t3,t4,t5,t6,t7) -> t1
fst_7 (x,y,z,a,b,c,w) = x
--
snd_7 :: (t1,t2,t3,t4,t5,t6,t7) -> t2
snd_7 (x,y,z,a,b,c,w) = y
--
thr_7 :: (t1,t2,t3,t4,t5,t6,t7) -> t3
thr_7 (x,y,z,a,b,c,w) = z
--
th4_7 :: (t1,t2,t3,t4,t5,t6,t7) -> t4
th4_7 (x,y,z,a,b,c,w) = a
--
th5_7 :: (t1,t2,t3,t4,t5,t6,t7) -> t5
th5_7 (x,y,z,a,b,c,w) = b
--
th6_7 :: (t1,t2,t3,t4,t5,t6,t7) -> t6
th6_7 (x,y,z,a,b,c,w) = c
--
th7_7 :: (t1,t2,t3,t4,t5,t6,t7) -> t7
th7_7 (x,y,z,a,b,c,w) = w
--
get7N :: (Eq a, Num a) => a -> ([a1], [a1], [a1], [a1], [a1], [a1], [a1]) -> [a1]
get7N n x
   | n == 1  = fst_7 x
   | n == 2  = snd_7 x
   | n == 3  = thr_7 x
   | n == 4  = th4_7 x
   | n == 5  = th5_7 x
   | n == 6  = th6_7 x
   | n == 7  = th7_7 x
   | otherwise = []
--      DESCRICAO
--         Retorna um dos elementos da 7-upla
--
--
--
--
--
group1 :: [[Char]] -> [([Char],[Char],[Char],[Char],[Char],[Char],[Char])]
group1 xs
   | xs == []  = []
   | otherwise = [(x,"","","","","","")| x<-xs]
--
group2 :: [[Char]] -> [([Char],[Char],[Char],[Char],[Char],[Char],[Char])]
group2 xs
     | xs          == [] = []
     | (length xs)  < 2  = group1 xs

     | otherwise         = [(xs!!0,xs!!1,"","","","","")] ++ (group2 (drop 2 xs))
--
group3 :: [[Char]] -> [([Char],[Char],[Char],[Char],[Char],[Char],[Char])]
group3 xs
     | xs          == [] = []
     | (length xs)  < 3  = group2 xs
     | otherwise         = [(xs!!0,xs!!1,xs!!2,"","","","")] ++ (group3 (drop 3 xs))
--
group4 :: [[Char]] -> [([Char],[Char],[Char],[Char],[Char],[Char],[Char])]
group4 xs
     | xs          == [] = []
     | (length xs)  < 4  = group3 xs
     | otherwise         = [(xs!!0,xs!!1,xs!!2,xs!!3,"","","")] ++ (group4 (drop 4 xs))
--
group5 :: [[Char]] -> [([Char],[Char],[Char],[Char],[Char],[Char],[Char])]
group5 xs
     | xs          == [] = []
     | (length xs)  < 5  = group4 xs
     | otherwise         = [(xs!!0,xs!!1,xs!!2,xs!!3,xs!!4,"","")] ++ (group5 (drop 5 xs))
--
group6 :: [[Char]] -> [([Char],[Char],[Char],[Char],[Char],[Char],[Char])]
group6 xs
     | xs          == [] = []
     | (length xs)  < 6  = group5 xs
     | otherwise         = [(xs!!0,xs!!1,xs!!2,xs!!3,xs!!4,xs!!5,"")] ++ (group6 (drop 6 xs))
--
group7 :: [[Char]] -> [([Char],[Char],[Char],[Char],[Char],[Char],[Char])]
group7 xs
     | xs          == [] = []
     | (length xs)  < 7  = group6 xs
     | otherwise         = [(xs!!0,xs!!1,xs!!2,xs!!3,xs!!4,xs!!5,xs!!6)] ++ (group7 (drop 7 xs))
--
groupN :: Int -> [[Char]] -> [([Char],[Char],[Char],[Char],[Char],[Char],[Char])]
groupN n xs
    | n == 1    = group1 xs
    | n == 2    = group2 xs
    | n == 3    = group3 xs
    | n == 4    = group4 xs
    | n == 5    = group5 xs
    | n == 6    = group6 xs
    | otherwise = []
--
--      DESCRICAO
--         Dada uma lista de strings onde de n em n elementos os dados so corresposndentes.
--         As funcoes agrupam esses dados em 7-uplas guardando a sequencia entre si
--      PARAMETROS
--         Entrada:
--            Lista de String
--         Saida:
--            Lista de 7-uplas com os campos separados
--      EXEMPLO
--         ghci> lista1 = ["1","JANEIRO","2000","22","ABRIL","1500","25","DEZEMBRO","2019"]
--         ghci> group3 lista1
--         ghci> [("1","JANEIRO","2000","","",""),("22","ABRIL","1500","","",""),("25","DEZEMBRO","2019","","","")]
--         ghci>
--         ghci> lista2 = ["Brasil","Brasilia","Argentina","Buenos Aires","Uruguai","Montevideo"]
--         ghci> group2 lista
--         ghci> [("Brasil","Brasilia","","","",""),("Argentina","Buenos Aires","","","",""),("Uruguai","Montevideo","","","","")]
--
--
{- ########################################################################################################################################################################## -}
{-                                                                                     MAIN                                                                                   -}
{- ###########################################################################################################################################################################-}
main :: IO()
main = do
   args <- getArgs
   putStrLn "############################################################################################################################################################"
   putStrLn "                                                        BATERIA DE TESTES DO MODULO FileManipularo.hs"
   putStrLn "############################################################################################################################################################"
   putStrLn "TESTE01 - Verificar a quantidade de parametros de entrada"
   putStr   "  "
   checkerArgsMsn args
   if (checkerArgsB args) -- Verifica a presentaca dinDocenos parametros na lista de argumentos
      then
         if (thereIsParamMiss specs args) -- Verifica se todos os especificadores estao presente
            then
               putStrLn "   |---> Ha especificador que nao foi passado!"
            else do
               putStrLn "   |---> Todos especificadores previstos foram passado!"
      else
         putStrLn "   |---> Ha problemas com a quantidade de argumentos passado"

   putStrLn "|=====================================================|"
   putStrLn "|               FileManipulator.hs 1.2                |"
   putStrLn "|               developed and designed                |"
   putStrLn "|                    by Alanesvit                     |"
   putStrLn "|=====================================================|"