   {- ####################################################################################################
   ####                                                                                               ####
   ####             UNIVERSIDADE FEDERAL DO ESPIRITO SANTO                                            ####
   ####             CENTRO TECNOLOGICO                                                                ####
   ####             DEPARTAMENTO DE INFORMATICA                                                       ####
   ####             ENGENHARIA DE COMPUTACAO                                                          ####
   ####             Linguagens de Programacao 2019/2                                                  ####
   ####             Professor Vitor E. Silva Souza                                                    ####
   ####                                                                                               ####
   #######################################################################################################
   ####                                                                                               ####
   ####                                       TRABALHO SOBRE A                                        ####
   ####                                  A LINGUAGEM DE PROGRAMACAO                                   ####
   ####                                         H A S K E L L                                         ####
   ####                                                                                               ####
   #######################################################################################################
   ##################                                ***                                ##################
   ##################                              m a i n                              ##################
   ##################                                ***                                ##################
   #######################################################################################################
   #######################################################################################################
   ####        AUTOR: Alan do Espirito Santo Vitorino                                                 ####
   ####               Bruno Gomes                                                                     ####
   ####               Victor de Oliveira                                                              ####
   ####                                                                                               ####
   ####        DATA ABERTURA: 07 de novembro de 2019, as 20h53min                                     ####
   ####        LOCAL: Brasil, Espirito Santo, Vitoria                                                 ####
   ####                                                                                               ####
   ####        DATA ENCERRAMENTO: 13 de dezembro de 2019, as 00h47min                                 ####
   ####        LOCAL: Brasil, Espirito Santo, Vitoria,                                                ####
   ####                                                                                               ####
   ####        VERSAO  1.2                                                                            ####
   ####                                                                                               ####
   ####        OBJETIVOS                                                                              ####
   ####           Processar dados provenientes de 7 arquivos e consolida-los em 4 arquivos            ####
   ####                                                                                               ####
   ####        DESCRICAO                                                                              ####
   ####           Abre 7 arquivos de extensao csv;                                                    ####
   ####           Le os dados;                                                                        ####
   ####           Processa informacoes ao cruzar dados entre arquivos;                                ####
   ####           Consolida os dados em 4 arquivos de saida.                                          ####
   ####                                                                                               ####
   ####        PENDENCIAS:                                                                            ####
   ####             tratamento de execoes                                                             ####
   ####                                                                                               ####
   ####        ATUALIZACOES/MODIFICACOES/ACRESCIMOS                                                   ####
   ####             *                                                                                 ####
   ####             * 2019_12_13_00h42min:                                                            ####
   ####                  - Conclusao v 1.0                                                            ####
   ####                     Gera os 4 relatorios sem tratamento de excecoes                           ####
   ####             * 2019_12_13_12h00min                                                             ####
   ####                  - Conclusao v 1.2                                                            ####
   ####                    + Versao de entrega                                                        ####
   ####                                                                                               ####
   #################################################################################################### -}

import ArgsTester
import DocsSpecifications
import FileManipulator
import System.Environment(getArgs)
import Data.List.Split -- Biblioteca para usar a função splitOn. Teve que ser baixada -> sudo apt-get install cabal-install 
--
{-
   AUTOR: Alan do Espirito Santo Vitorino
   DATA ABERTURA: 14 de novembro de 2019, as 18h15min
   ORIENTACOES
      Para WinGHCi 1.0.6 no Windows 7 PC Athlon 2 x2
      Configurar argumentos de entrada:
      :set args argumento1 argumento2 argumento3 argumento1
      argumentos padrao
      Antes de chamar a main configure os parametros no GHCi digitando a linha >:set ...
   EXEMPLO
      >:load Main.hs
      >:set args -d docentes.csv -a discentes.csv -p producoes.csv -c cursos.csv -r aulas.csv -og orientagrad.csv -op orientapos.csv
      > main -}
--
{- ########################################################################################################################################################################## -}
{-                                                                                     MAIN                                                                                   -}
{- ###########################################################################################################################################################################-}
main :: IO()
main = do
   argsChecker
   args <- getArgs
   putStrLn "TESTE01 - Verificar a quantidade de parametros de entrada"
   putStr   "  "
   checkerArgsMsn args
   if (checkerArgsB args) -- Verifica a presentaca dinDocenos parametros na lista de argumentos
      then
         if (thereIsParamMiss specs args) -- Verifica se todos os especificadores estao presente
            then
               putStrLn "   |---> Ha especificador que nao foi passado!"
            else do
               putStrLn "   |---> Todos especificadores previstos foram passado!"
      else
         putStrLn "   |---> Ha problemas com a quantidade de argumentos passado"
--
--
-- Le todo o conteudo das planilha-}
   conteudoDocent <- readDocent args
   conteudoDiscen <- readDiscen args
   conteudoProCie <- readProCie args
   conteudoCursos <- readCursos args
   conteudoDiscip <- readDiscip args
   conteudoOriGra <- readOriGra args
   conteudoOriPos <- readOriPos args
--
--
-- Transforma a lista de linhas, separados por ";", em lista de dados, -}
   let lsDocent1 = [ x | y<-conteudoDocent, x<- (splitOn ";" y)]
   let lsDiscen1 = [ x | y<-conteudoDiscen, x<- (splitOn ";" y)]
   let lsProCie1 = [ x | y<-conteudoProCie, x<- (splitOn ";" y)]
   let lsCursos1 = [ x | y<-conteudoCursos, x<- (splitOn ";" y)]
   let lsDiscip1 = [ x | y<-conteudoDiscip, x<- (splitOn ";" y)]
   let lsOriGra1 = [ x | y<-conteudoOriGra, x<- (splitOn ";" y)]
   let lsOriPos1 = [ x | y<-conteudoOriPos, x<- (splitOn ";" y)]
--
--
-- Converte os dados de uma lista continua de strings em uma lista de dados em 7-upla -}
   let lsDocent2 = groupN 3 lsDocent1
   let lsDiscen2 = groupN 3 lsDiscen1
   let lsProCie2 = groupN 3 lsProCie1
   let lsCursos2 = groupN 4 lsCursos1
   let lsDiscip2 = groupN 6 lsDiscip1
   let lsOriGra2 = groupN 4 lsOriGra1
   let lsOriPos2 = groupN 5 lsOriPos1
--
--
-- Computacao da planilha de Relatorio de Horas Aula
   let rha1 = [ (get7N 3 x, get7N 2 x, get7N 6 y,get7N 5 y,""        , "", "") | x<-lsDocent2,  y<-lsDiscip2, (get7N 1 x) == (get7N 3 y)]
   let rha2 = [ (get7N 1 x, get7N 2 x, get7N 3 x,get7N 2 y,get7N 4 x , "", "") | x<-rha1,       y<-lsCursos2, (get7N 1 y) == (get7N 3 x)] 
   let rha3 = quicksortRHA  rha2
   let rha4 = reverse  rha3
   let rha5 = somaRHA rha4
--
--
-- Computacao da planilha de Plano Semestral das Atividades Docentes
   let pad1 = [(get7N 2 x, get7N 3 x, get7N 4 y, get7N 5 y, "0"      , "0" ,"0") | x<-lsDocent2, y<-lsDiscip2, (get7N 1 x) == (get7N 3 y)]
   let pad2 = [(get7N 2 x, get7N 3 x, "0"      , "0"      , get7N 5 y, "0" ,"0") | x<-lsDocent2, y<-lsOriPos2, (get7N 1 x) == (get7N 1 y)]
   let pad3 = [(get7N 2 x, get7N 3 x, "0"      , "0"      , get7N 4 y, "0" ,"0") | x<-lsDocent2, y<-lsOriGra2, (get7N 1 x) == (get7N 1 y)]
   let pad4 = [ if ( ((get7N 3 y) =="x") || ((get7N 3 y) =="X") || ((get7N 3 y) =="") )
                  then  (get7N 2 x, get7N 3 x, "0"      , "0"      , "0"      , "1"    ,"0")
                  else  (get7N 2 x, get7N 3 x, "0"      , "0"      , "0"      , "0"    ,"1")
                      | x<-lsDocent2, y<-lsProCie2, (get7N 1 x) == (get7N 1 y)]
   let pad5 = quicksortPAD (pad1 ++ pad2 ++ pad3 ++ pad4)
   let pad6 = reverse pad5
   let pad7 = somaPAD pad6
--
--
-- Computacao da planilha de Tabela de Alocacao de Disciplina
   let alo1 = [(get7N 2 x, get7N 1 y, get7N 2 y, get7N 5 y,"0","0","0") | x<-lsDocent2, y<-lsDiscip2, (get7N 1 x) == ( get7N 3 y)]
   let alo2 = quicksortALO alo1
   let alo3 = reverse alo2
--
--   
-- Computacao da planilha de Lista de Discentes de Pos-Graduacao
   let ppg1 = [(get7N 4 x, (procData(get7N 3 x)), get7N 2 x, get7N 2 y,"0","0","0")| x<-lsOriPos2, y<-lsDiscen2, (get7N 2 x)==(get7N 1 y)]
   let ppg2 = quicksortPPG ppg1
   let ppg3 = reverse ppg2
--
--   
-- Criacao dos arquivos de saida com seus respectivos cabecalhos
   putLnPAD headerPAD
   putLnRHA headerRHA
   putLnALO headerAlo
   putLnPPG headerPPG
--
--
-- Adendo nos arquivos de saida de dados resultantes dos processamentos.
   putLsUplaPAD pad7
   putLsUplaRHA rha5
   putLsUplaALO alo3
   putLsUplaPPG ppg3

   putStrLn "|=====================================================|"
   putStrLn "|                    Main.hs 1.2                      |"
   putStrLn "|               developed and designed                |"
   putStrLn "|                    by Alanesvit                     |"
   putStrLn "|=====================================================|"

   
   
   
   
   
   
